Imports Microsoft.VisualBasic
Imports System
Imports System.Data
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports Telerik.Web.UI
Imports System.Diagnostics
Imports System.Threading

Public Class OpenAccessTracer
	Inherits TraceListener
	Private id As Integer
	Private count As Integer
	Private textBox As RadTextBox
	Private label As Label
	Private myThread As Thread

	Public Sub New(ByVal textBox As RadTextBox)
		MyBase.New("OpenAccess")

		myThread = Thread.CurrentThread

		Telerik.OpenAccess.Diagnostics.TraceAdapter.Instance.Level = "4"
		id = Telerik.OpenAccess.Diagnostics.TraceAdapter.Instance.Listeners.Add(Me)
		Me.textBox = textBox

		count = 0
	End Sub

	Public Sub New(ByVal textBox As RadTextBox, ByVal label As Label)
		MyBase.New("OpenAccess")

		myThread = Thread.CurrentThread

		Telerik.OpenAccess.Diagnostics.TraceAdapter.Instance.Level = "4"
		id = Telerik.OpenAccess.Diagnostics.TraceAdapter.Instance.Listeners.Add(Me)
		Me.textBox = textBox
		Me.label = label
		count = 0
	End Sub

	Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
		Me.textBox.Text += count.ToString() & " queries executed."
		Telerik.OpenAccess.Diagnostics.TraceAdapter.Instance.Listeners.RemoveAt(id)
		MyBase.Dispose(disposing)
	End Sub

	Public Sub Reset()
		textBox.Text = ""
		count = 0
	End Sub

	Public Overrides Overloads Sub Write(ByVal message As String)

	End Sub

	Public Overrides Overloads Sub WriteLine(ByVal message As String)
		If (Not myThread.Equals(Thread.CurrentThread)) Then
			Return
		End If

		If label IsNot Nothing Then
			label.Text = count.ToString() & " queries executed."
		End If

		If message.StartsWith("driver.stat.execQuery") Then
			count += 1
			textBox.Text += String.Format("{0}: {1}" & Constants.vbCrLf, count.ToString(), message.ToString().Substring(33))
		End If
	End Sub
End Class