Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports Telerik.OpenAccess
Imports PersistentClasses

Partial Public Class FetchPlans
	Inherits System.Web.UI.UserControl
	Private tracer As OpenAccessTracer = Nothing

	Protected Sub RadGrid1_NeedDataSource(ByVal source As Object, ByVal e As Telerik.Web.UI.GridNeedDataSourceEventArgs)
		If Session("tracer") Is Nothing Then
			tracer = New OpenAccessTracer(RadTextBox1, Label1)
			Session("tracer") = tracer
		Else
			CType(Session("tracer"), OpenAccessTracer).Reset()
		End If

		Dim scope As IObjectScope = ObjectScopeProvider1.ObjectScope()
		' clears the scope 1st level cache
		scope.Transaction.Begin()
		scope.Transaction.Commit()

		If CheckBox1.Checked Then
			scope.FetchPlan.Clear()
			scope.FetchPlan.Add(FetchPlan.Default)
			scope.FetchPlan.Add("Invoice Fetch Group")
			scope.FetchPlan.MaxDepth = 3
			Label2.Text = "Try paging and sorting with the Use fetch plan option disabled. Note the number of executed queries."

		Else
			scope.FetchPlan.Clear()
			scope.FetchPlan.Add(FetchPlan.Default)
			Label2.Text = "Enable the Use fetch plan option and try paging and sorting. The number of executed queries will be decreased."

		End If

		Dim query As IQuery = scope.GetOqlQuery("select * from OrderExtent as o")
		query.ParallelFetch = CheckBox1.Checked
		Dim result As IQueryResult = query.Execute()

		Dim count As Integer = result.Count

		RadGrid1.DataSource = result
	End Sub

	Protected Sub CheckBox1_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs)


		RadTextBox1.Text = ""
		RadGrid1.Rebind()


	End Sub

	Public Overrides Sub Dispose()
		If Session("tracer") IsNot Nothing Then
			CType(Session("tracer"), OpenAccessTracer).Dispose()
			Session("tracer") = Nothing
		End If

		MyBase.Dispose()
	End Sub
	Protected Sub RadGrid1_PageIndexChanged(ByVal source As Object, ByVal e As Telerik.Web.UI.GridPageChangedEventArgs)
		RadTextBox1.Text = ""
	End Sub
End Class
